<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: mirabel.class.php,v 1.1.2.1 2022/09/20 12:36:38 dbellamy Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

global $class_path;

require_once $class_path."/connecteurs.class.php";
require_once __DIR__."/mirabel_client.class.php";

class mirabel extends connector {
	
    protected $mirabel_api_url = '';
    protected $mirabel_api_key = '';
        
    public function __construct($connector_path="") 
    {
    	parent::__construct($connector_path);
    }
    
    
    public function get_id() 
    {
    	return "mirabel";
    }
    
    //Est-ce un entrepot ?
	public function is_repository() 
	{
		return 2;
	}
    
	
	protected function unserialize_source_params($source_id) {
	    
	    $params = parent::unserialize_source_params($source_id);
	    if(!empty($params['PARAMETERS']['mirabel_api_url'])) {
	        $this->mirabel_api_url = $params['PARAMETERS']['mirabel_api_url'];
	    }
	    if(!empty($params['PARAMETERS']['mirabel_api_key'])) {
	        $this->mirabel_api_key = $params['PARAMETERS']['mirabel_api_key'];
	    }
	    return $params;
	}
	
	
	public function make_serialized_source_properties($source_id)
	{
	    global $mirabel_api_url, $mirabel_api_key;
	    
	    if(empty($mirabel_api_url)) {
	        $mirabel_api_url = '';
	    }
	    if(empty($mirabel_api_key)) {
	        $mirabel_api_key = '';
	    }
	    
	    $this->sources[$source_id]['PARAMETERS'] = serialize(
	        [
	            'mirabel_api_url'  => stripslashes($mirabel_api_url),
	            'mirabel_api_key'  => stripslashes($mirabel_api_key),
	        ]
	    );
	}
	
	
	public function source_get_property_form($source_id) 
	{
	    global $charset;
	    
	    $this->unserialize_source_params($source_id);
	    
	    if(!$this->mirabel_api_url) {
	        $this->mirabel_api_url = mirabel_client::API_URL_DEFAULT;
	    }
	    
	    $form = "
			<h3>".$this->msg['mirabel_ws']."</h3>
			<div class='row'>&nbsp;</div>
				    
			<div class='row'>
				<div class='colonne3'>
					<label for='mirabel_api_url'>".$this->msg["mirabel_api_url"]."</label>
				</div>
				<div class='colonne_suite'>
					<input type='text' name='mirabel_api_url' id='mirabel_api_url' class='saisie-80em' value='".htmlentities($this->mirabel_api_url,ENT_QUOTES,$charset)."' />
				</div>
			</div>

			<div class='row'>
				<div class='colonne3'>
					<label for='mirabel_api_key' >".$this->msg["mirabel_api_key"]."</label>
				</div>
				<div class='colonne_suite'>
					<input type='text' name='mirabel_api_key' id='mirabel_api_key' class='saisie-30em' autocomplete='off' value='".htmlentities($this->mirabel_api_key,ENT_QUOTES,$charset)."' />
				</div>
			</div>";
	    
	    return $form;
	}
	
	
	public function enrichment_is_allow(){
		return true;
	}

	public function getTypeOfEnrichment($source_id)
	{
	    $type = [
	        'type'         => [],
	        'source_id'    => $source_id,
	    ];
	    return $type;
	}
}
