<?php
// +-------------------------------------------------+
// | 2002-2011 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: mails_configuration_controller.class.php,v 1.2.2.4 2022/09/27 09:47:07 dgoron Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

global $class_path;
require_once($class_path."/mails/mail_configuration.class.php");

class mails_configuration_controller extends lists_controller {
	
	protected static $model_class_name = 'mail_configuration';
	
	protected static $list_ui_class_name = 'list_mails_configuration_ui';
	
	public static function proceed($id=0) {
		global $action;
		global $name;
		
		$id = intval($id);
		switch ($action) {
			case 'edit':
				if(!empty($name)) {
					$model_instance = static::get_model_instance($name);
					if(pmb_error::get_instance(static::$model_class_name)->has_error()) {
						pmb_error::get_instance(static::$model_class_name)->display(1, static::get_url_base());
					} else {
						print $model_instance->get_form();
					}
				} else {
					static::redirect_display_list();
				}
				break;
			case 'save':
				$model_instance = static::get_model_instance($name);
				$model_instance->set_properties_from_form();
				$model_instance->save();
				
				static::redirect_display_list();
				break;
			case 'delete':
				$model_class_name = static::$model_class_name;
				$model_class_name::delete($name);
				
				static::redirect_display_list();
				break;
			default:
				if (SESSrights & ADMINISTRATION_AUTH) {
					parent::proceed($id);
				}
				break;
		}
	}
	
	public static function redirect_display_list() {
		global $current_module;
		global $name;
		
		if ($current_module == 'admin' && SESSrights & ADMINISTRATION_AUTH) {
			$location_url = static::get_url_base();
		} else {
			$location_url = static::get_url_base()."&action=edit&name=".$name;
		}
		if(headers_sent()) {
			print "
				<script type='text/javascript'>
					window.location.href='".$location_url."';
				</script>";
		} else {
			header('Location: '.$location_url);
		}
	}
}