<?php
use Pmb\Common\Views\NavbarView;

// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: navbar.inc.php,v 1.28.2.3 2022/09/06 07:53:23 gneveu Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php"))
    die("no access");

global $base_path;
require_once ($base_path . '/includes/javascript/form.inc.php');

function getNavbar($page, $nbr_lignes, $nb_per_page, $url, $nb_per_page_custom_url = "&nb_per_page_custom=!!nb_per_page_custom!!", $action = ''){
    global $opac_items_pagination_custom, $cms_active;
    // on fait suivre les variables d'environnement du portail
    
    if ($cms_active && strpos($url, 'javascript:') === false) {
        $query = "select distinct var_name from cms_vars";
        $result = pmb_mysql_query($query);
        if (pmb_mysql_num_rows($result)) {
            while ($row = pmb_mysql_fetch_object($result)) {
                $var_name = $row->var_name;
                global ${$var_name};
                if (! empty(${$var_name}) && strpos($url, $var_name."=") === false) {
                    $url .= "&" . $var_name . "=" . rawurlencode(${$var_name});
                }
            }
        }
    }
    $navbar = new NavbarView($page, $nbr_lignes, $nb_per_page, $url, $nb_per_page_custom_url, $action);
    $navbar->setCustoms($opac_items_pagination_custom);
    return $navbar;
}

function printnavbar($page, $nbr_lignes, $nb_per_page, $url, $nb_per_page_custom_url = "&nb_per_page_custom=!!nb_per_page_custom!!", $action = '')
{
    $navbar = getNavbar($page, $nbr_lignes, $nb_per_page, $url, $nb_per_page_custom_url, $action);
    return $navbar->render();
}

function printnavbar_onclick($page, $nbrpages, $url,$action='') {
    global $msg;
    
    $page = intval($page);
    $precedente = $page-1;
    $suivante = $page+1;
    
    
    // affichage de la barre de navigation
    $print = "<div class=\"navbar\">\n";
    
    $print .= "<form name='form' onsubmit=\"document.getElementById('page').value=document.getElementById('navbar_input_page').value;$action\">\n";
    // first
    if ($page != 1)	{
        $print .= "<img src='".get_url_icon('first.png')."' alt='".$msg["first_page"]."' style='border:0px' title='".$msg["first_page"]."' onclick=\"document.getElementById('page').value=1;$action\">\n";
    }else {
        $print .= "<img src='".get_url_icon('first-grey.png')."' alt='".$msg["first_page"]."'>\n";
    }
    // prev
    if ($precedente >= 1) {
        $print .= "<img src='".get_url_icon('prev.png')."' alt='".$msg["prec_page"]."' style='border:0px' title='".$msg["prec_page"]."'  onclick=\"document.getElementById('page').value=$precedente;$action\">\n";
    }else {
        $print .= "<img src='".get_url_icon('prev-grey.png')."' alt='".$msg["prec_page"]."'>\n";
    }
    // page courante
    if ($nbrpages > 1) {
        $print .= $msg['page']." <input type='text' class='numero_page' name='page' id='navbar_input_page' value='$page' size='".strlen("$nbrpages")."'>/$nbrpages\n";
    }else {
        $print .= $msg['page']." $page/$nbrpages\n";
    }
    // next
    if ($suivante <= $nbrpages) {
        
        $print .= "<img src='".get_url_icon('next.png')."' alt='".$msg["next_page"]."' style='border:0px' title='".$msg["next_page"]."' onclick=\"document.getElementById('page').value=$suivante;$action\">\n";
    } else {
        $print .= "<img src='".get_url_icon('next-grey.png')."' alt='".$msg["next_page"]."'>\n";
    }
    // last
    if ($page != $nbrpages)	{
        $print .= "<img src='".get_url_icon('last.png')."' alt='".$msg["last_page"]."' style='border:0px' title='".$msg["last_page"]."' onclick=\"document.getElementById('page').value=$nbrpages;$action\">\n";
    }else {
        $print .= "<img src='".get_url_icon('last-grey.png')."' alt='".$msg["last_page"]."'>\n";
    }
    $print .= "</form>\n";
    $print .= "</div>\n";
    return $print;
}
